/** ***************************************************************************
  * @file    lcd_1602.c																												*
  * @author  PLUM, Maciej Szumski																							*
  * @version V1.0																															*
  * @date    12-February-2016																									*
  * @brief   This file contains all functions for the LCD1602									*
  *****************************************************************************/
	#include "lcd_1602.h"
//	#include ".\..\Drivers\KAmodKB4x4\KB_4x4.h"
//-----------------------------------------------------------------------------
void LCD_WriteText(unsigned char * text) {
  while(*text){
		if (*text == 0x0A){
			LCD_GoTo(0,1);
			text++;
		}
		else
			LCD_WriteCharacter(*text++);
	}
}
//-----------------------------------------------------------------------------
void LCD_GoTo(unsigned char x, unsigned char y) {
  LCD_SendCommand(LCD_DDRAM_SET | (x + (0x40 * y)));
}
//-----------------------------------------------------------------------------
void LCD_WriteTextXY(unsigned char * text, unsigned char x, unsigned char y){
  LCD_GoTo(x,y);
  LCD_WriteText((unsigned char *)text);
}
//-----------------------------------------------------------------------------
void LCD_SetUserChar (unsigned char chrNum, unsigned char n, const unsigned char *p) {
     //chrNum  - od którego znaku zacząć (0 - 7)
     //n       - ilość znaków do wpisania
     //*p      - wskaźnik na tablice ze wzorcem znaków
	LCD_SendCommand(LCD_CGRAM_SET | chrNum * 8);
	n *= 8;
	do
		LCD_WriteCharacter(*p++);
	while (--n);
	LCD_SendCommand(LCD_CLEAR);    // przywraca adresy do DDRAM
	
}
//-----------------------------------------------------------------------------
void LCD_WriteBin(unsigned int var, int bitCount){
  int i;
  
  for(i = (bitCount - 1); i >= 0; i--) {
     LCD_WriteCharacter((var & (1 << i))?'1':'0');
     }
}
/**************** (C) COPYRIGHT 2016 PLUMicroelectronics *****END OF FILE******/	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	





