;********************************************
;* Programy asemblerowe     04-02-2016		*
;********************************************
			AREA AsmCode, CODE, READONLY

;--------- Read main stack pointer ----------
;INPUT:  void
;OUTPUT: r0 = MSP
			EXPORT get_MSP
			ALIGN
get_MSP		PROC
			MRS  r0,msp
			BX   lr
			ENDP
				
;--------- Write main stack pointer ---------
;INPUT:  r0 = MSP
;OUTPUT: void
			EXPORT set_MSP
			ALIGN
set_MSP		PROC
			MSR  msp,r0
			BX   lr
			ENDP

;-------- Read process stack pointer --------
;INPUT:  void
;OUTPUT: r0 = PSP
			EXPORT get_PSP
			ALIGN
get_PSP		PROC
			MRS  r0,psp
			BX   lr
			ENDP
				
;------- Write process stack pointer --------
;INPUT:  r0 = PSP
;OUTPUT: void
			EXPORT set_PSP
			ALIGN
set_PSP		PROC
			MSR  psp,r0
			BX   lr
			ENDP
			
;--- odczytaj adres powrotu ze stosu MSP ----
; odczytuje adres instrukcji, ktora wywolala
; 		  Hard Fault exception
;INPUT:  void
;OUTPUT: r0 = return address (MSP)
			EXPORT get_return_addr
			ALIGN
get_return_addr	PROC
			MRS  r0,msp
			LDR  r0,[r0,#24]
			BX   lr
			ENDP

;-------- obsluga przerwania SysTick --------
;INPUT:  void
;OUTPUT: void
			IMPORT get_next_task
			IMPORT update_sp
			
			EXPORT SysTick_Handler
			ALIGN
SysTick_Handler	PROC
			CPSID I		; set PRIMASK to disable IRQ
			
			TST		lr,#0x04
			MRSEQ	r0,msp
			MRSNE	r0,psp
			STMDB	r0!,{r4-r11}
			MSREQ	msp,r0
			MSRNE	psp,r0
			
			BL		update_sp;
			BL		get_next_task
			MOV		lr,r0
			
			TST		lr,#0x04
			MRSEQ	r0,msp
			MRSNE	r0,psp
			LDMFD	r0!,{r4-r11}
			MSREQ	msp,r0
			MSRNE	psp,r0
			
			CPSIE 	I 	; clear PRIMASK to enable IRQ
			BX   	lr
			ENDP
				
;--------- Report HardFault when things goes wrong ----------
;INPUT:  void
;OUTPUT: r0 = MSP / PSP
			IMPORT HardFault_Handler_C
				
			EXPORT HardFault_Handler
			ALIGN
HardFault_Handler	PROC
			TST    LR, #4
			ITE    EQ
			MRSEQ  r0, msp
			MRSNE  r0, psp
			B      HardFault_Handler_C
			ENDP						
					
			
			END
				





